// Copyright 2009, Gabriele Facciolo <gabriele.facciolo@upf.edu>
// Copyright 2009, Pablo Arias <pablo.arias@upf.edu>
// All rights reserved.

// TODO NO MEDIAN YET

/* 
 *
 *
 * TYPE_AB IMPLEMENTS the algorithm with transmission of information from in both ways .  a(x)  U  a(x')
 *
 *
 *
 * */


Point compute_bestmatch_at_pointAB( PointGrid *grid, Point m, int Nsize, int WindSize, Dimage interp, double *weight, PointList** BIGOUT ,int N) {
	PointList refPL ,searchNeigh,TP, putPL;
	assert(N<= WindSize);
	// ATTENTION! this makes consider all the point
	//TODO	
	//N=WindSize;

	// GETS THE NEIGHBORHOOD OF THE CURRENT POINT (m) 
	getNearestNeighbours_center_cache(interp, grid, m, Nsize, refPL);

	// GETS THE POINTS IN THE COMPARISON WINDOW
	searchNeigh =  grid->getNearestNeighbours(m.x,m.y,WindSize);  
	if(NOCENTER()) remove_Neighborhood_center(searchNeigh, m);

	// FOR EACH POINT IN searchNeigh
	for (int i=0; i < searchNeigh.size(); i++) {
		double dist2;
		Point P = searchNeigh[i];
		// COMPARE refPL WITH THE IMAGE
		getNearestNeighbours_center_cache(interp, grid, P, Nsize, putPL);
		dist2 = compute_dist_two( m, putPL, P,refPL, interp) ; 

		P.dist2 = dist2;
		addPT(&TP,P,N); // stores the N Points with shortest dist2
	}

	// compute the normalization constant
	double Rho= 0;
	for(int t=0;t<N;t++) {
		Point P = TP[t];
		Rho += exp(-P.dist2 / TAU); // COMPUTE r
	}
	//if(Rho ==0) printf("Rho is 0\n");

	// perform the transfers
	for(int t=0;t<N;t++) {
		Point P = TP[t];

		double r= exp(-P.dist2 / TAU); // COMPUTE r

		/* RECEPTION */
		// EXTRACT REMOTE NEIGHBORHOOD x'
		getNearestNeighbours_center_cache(interp, grid, P, Nsize, putPL);

      double Gmass = 0;  // compute the total mass
      for (int j=0; j < refPL.size(); j++) {
         Gmass+=G(refPL[j].x*refPL[j].x + refPL[j].y*refPL[j].y);
      }
      for (int j=0; j < putPL.size(); j++) {
         Gmass+=G(putPL[j].x*putPL[j].x + putPL[j].y*putPL[j].y);
      }
		if(NONORMALIZE()|| NONORMALIZEDUPDATE() ) Gmass=1;

		assert(Gmass>0);

		// RECEPTION from putPL
		for (int j=0; j < putPL.size(); j++) {
			Point pact = putPL[j];
			int newx = (int) (m.x + pact.x );
			int newy = (int) (m.y + pact.y );
			if(newy>=0 && newx>=0 && newy < interp->nrow && newx < interp->ncol) {
				if (MEDIANS() ) 
				{ MEDIAN( BIGOUT[ newx + newy * interp->ncol ], pact.value , Rho?r/Rho:0 , G(pact.x*pact.x + pact.y*pact.y)/Gmass);}
				else
				{ MEAN(BIGOUT[newx + newy * interp->ncol], pact.value, Rho?r/Rho:0, G(pact.x*pact.x + pact.y*pact.y)/Gmass); }
			}
		}

		/* TRANSMISSION */
		// THE NEIGHBORHOOD CENTERED AT x IS ALREADY STORED IN refPL
		for (int j=0; j < refPL.size(); j++) {
			Point pact = refPL[j];
			int newx = (int) (P.x + pact.x );
			int newy = (int) (P.y + pact.y );
			if(newy>=0 && newx>=0 && newy < interp->nrow && newx < interp->ncol) {
				if (MEDIANS() ) 
				{ MEDIAN( BIGOUT[ newx + newy * interp->ncol ], pact.value , Rho?r/Rho:0 , G(pact.x*pact.x + pact.y*pact.y)/Gmass);}
				else
				{ MEAN(BIGOUT[newx + newy * interp->ncol], pact.value, Rho?r/Rho:0, G(pact.x*pact.x + pact.y*pact.y)/Gmass); }
			}
		}
	}
	// returns the minimal distance as well as the point
	*weight = TP[0].dist2;
	return (TP[0]);
}


/* 
 *
 *
 * TYPE_AB IMPLEMENTS the algorithm with transmission of information in both ways.  a(x)  U  a(x')
 *
 *              IN THE LIMIT CASE (\tau \to 0)
 *
 * */

Point compute_bestmatch_at_pointlimAB( PointGrid *grid, Point m, int Nsize, int WindSize, Dimage interp, double *weight, PointList** BIGOUT ,int N) {
	PointList refPL ,searchNeigh,TP, putPL;
	assert(N<= WindSize);

	// ATTENTION! this makes consider all the point
	//TODO	

	// GETS THE NEIGHBORHOOD OF THE CURRENT POINT (m) 
	getNearestNeighbours_center_cache(interp, grid, m, Nsize, refPL);

	// GETS THE POINTS IN THE COMPARISON WINDOW
	searchNeigh =  grid->getNearestNeighbours(m.x,m.y,WindSize);  
	if(NOCENTER()) remove_Neighborhood_center(searchNeigh, m);

	// FOR EACH POINT IN searchNeigh
	for (int i=0; i < searchNeigh.size(); i++) {
		double dist2;
		Point P = searchNeigh[i];
		// COMPARE refPL WITH THE IMAGE
		getNearestNeighbours_center_cache(interp, grid, P, Nsize, putPL);
		dist2 = compute_dist_two( m, putPL, P,refPL, interp) ; 
		P.dist2 = dist2;
		addPTmindist2(&TP,P); // stores the N Points with shortest dist2
	}

	// perform the transfers
	for(int t=0;t<TP.size();t++) {
		Point P = TP[t];

		// GET THE REMOTE NEIGHBORHOOD
		getNearestNeighbours_center_cache(interp, grid, P, Nsize, putPL);

		double mass = 0;  // compute the total mass
		for (int j=0; j < refPL.size(); j++) { 
			mass+=G(refPL[j].x*refPL[j].x + refPL[j].y*refPL[j].y); 
		}
		for (int j=0; j < putPL.size(); j++) { 
			mass+=G(putPL[j].x*putPL[j].x + putPL[j].y*putPL[j].y); 
		}
		if(NONORMALIZE()|| NONORMALIZEDUPDATE() ) mass=1;

		for (int j=0; j < putPL.size(); j++) {
			Point pact = putPL[j];
			int newx = (int) (m.x + pact.x );
			int newy = (int) (m.y + pact.y );
			if(newy>=0 && newx>=0 && newy < interp->nrow && newx < interp->ncol) {
				 MEANlim( BIGOUT[ newx + newy * interp->ncol ], pact.value , P.dist2 , G(pact.x*pact.x + pact.y*pact.y)/mass);
			}
		}
		for (int j=0; j < refPL.size(); j++) {
			Point pact = refPL[j];
			int newx = (int) (P.x + pact.x );
			int newy = (int) (P.y + pact.y );
			if(newy>=0 && newx>=0 && newy < interp->nrow && newx < interp->ncol) {
				 MEANlim( BIGOUT[ newx + newy * interp->ncol ], pact.value , P.dist2 , G(pact.x*pact.x + pact.y*pact.y)/mass);
			}
		}
	}
	// returns the minimal distance as well as the point
	*weight = TP[0].dist2;
	return (TP[0]);
}
