// Copyright 2009, Gabriele Facciolo <gabriele.facciolo@upf.edu>
// Copyright 2009, Pablo Arias <pablo.arias@upf.edu>
// All rights reserved.

#include "stdio.h"

typedef struct dimage {
	int nrow;
	int ncol;
	double *gray;
} *Dimage;

Dimage new_dimage(void)
{
	Dimage image;

	if ( !(image = (Dimage) (malloc(sizeof(struct dimage))) ) )
	{
		fprintf(stderr, "[new_dimage] Not enough memory\n");
		exit(1);
		return(NULL);
	}

	image->nrow = image->ncol = 0;
	image->gray = NULL;
	return(image);
}


Dimage new_dimage2(long nx, long ny){
	   Dimage t= new_dimage();
		t->ncol = nx;
		t->nrow = ny;
		t->gray = (double *) malloc(sizeof(double)*t->ncol*t->nrow);
		return (t);
}


void del_dimage(Dimage i) {
	if (i->gray) free(i->gray);
	free(i);
}

